﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class DrawingObjectBus : IDrawingObject
    {
        public DrawingBus? _bus = null;

        public DrawingObjectBus(DrawingBus bus)
        {
            _bus = bus;
        }

        public DrawingBus? Get_bus()
        {
            return _bus;
        }

        public DrawingBus getBus(DrawingBus? _bus) {
            return _bus;
        }

        public float Step => _bus?.Bus?.Step ?? 0;

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _bus?.GetCurrentPosition() ?? default;
        }

        public string? GetInfo()
        {
            return _bus?.GetDataForSave();
        }

        public void MoveObject(Direction direction)
        {
            _bus?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _bus.SetPosition(x, y, width, height);
        }

        void IDrawingObject.DrawingObject(Graphics g)
        {
            _bus.DrawTransport(g);
        }

        public static IDrawingObject Create(string data)
        {
            return new DrawingObjectBus(data.CreateDrawningCar());
        }
    }
}
